; LIFO stacks

(provide 'stk)
(require 'lib)
(require 'ref)
(require 'types)

(define stk::mark (types:make-mark 'stk))
(define (stk? o)
   (and (pair? o) (eq? (car o) stk::mark)))
(types:register 'stk stk?)

(define (stk:new)
   (cons stk::mark (ref:new '())))

(define (stk:empty? s)
   (ASSERT stk? s)
   (let ((r (cdr s)))
   (null? (ref:get r))))

(define (stk:push! s x)
   (ASSERT stk? s)
   (let ((r (cdr s)))
   (ref:set! r (cons x (ref:get r)))))

(define (stk:peek s)
   (ASSERT stk? s)
   (let ((r (cdr s)))
   (car (ref:get r))))

(define (stk:pop! s)
   (ASSERT stk? s)
   (let*
      ((r (cdr s))
       (o (ref:get r))
       (a (car o))
       (d (cdr o)))
      (ref:set! r d)
      a))

(define (stk->list s)
   (ASSERT stk? s)
   (ref:get (cdr s)))


(if #f (begin
(define test (stk:new))
(write (stk:empty? test))
(write (stk:push! test 1))
(write (stk:push! test 2))
(write (stk:push! test 3))
(write (stk:pop! test))
(write (stk->list test))))