;----------------------- Debugging aid for C language -------------------------
(provide 'cdebug)

(define cdebug #t)

;------ Simple exit-on-failure I/O checking ------
;   This is only to be used during early debugging phase,
;until OTOP can use its own I/O library and exception handling to debug self.

(define (errprintf . x)
   `(C:call 'fprintf 'stderr . ,x))

(declare-wf-macro (TRY0 x y)
     (? (== x y) (exit errno) 1))
(declare-wf-macro (TRY x)
     (TRY0 x -1))

(define-wf-macro (CHECK x y err)
     (? (== x y) 0 (comma errprint (const-strcat err "\n") (exit 10))))


;------ debug or not debug ------
(if cdebug
   (define (DBG.x) (apply errprintf x))
   (define (DBG.x) 1))
