; ----------------------=|=--- conout.m4 ---=|=-----------------------------
; --=-- A Generic VideoText to Console *output* Functor --=--

; Lots of info taken from the sources of the Linux console driver.
; note how we keep input from output separate, so we can
; further freely recombine them.

; To translate from m4 to HLM

(provide 'conout)


; ----- Parameters for the Functor -----

(define-signature ConoutVar

	_cell_(CursorXY)	; moving visual cursor
	_cell_(PutCharXY)dnl		outputting a character
	_cell_(GetCharXY)dnl		reading a character

	_cell_(ConsoleFlags)dnl		flags
	_cell_(ConsoleMode)dnl		console mode
	_cell_(CharAttribute)dnl	attribute for characters
	_cell_(CurrentLine)dnl		line number
	_cell_(CurrentColumn)dnl	column number
	_cell_(Command,4)dnl		scratchpad memory for current command
})

define({ConoutFlag_EOL},		0x0001)	; are we at the end of line ?
define({ConoutFlag_ExistsCursor},	0x0002) ; is the cursor anywhere ?
define({ConoutFlag_CR_LFed},		0x0004) ; did a CR just auto-LF ?
define({ConoutFlag_LF_CRed},		0x0008) ; did a LF just auto-CR ?

define({ConoutMode_HideCursor},		0x0100)
define({ConoutMode_AutoCRLF},		0x0200)
define({ConoutMode_CRdoesLF},		0x0400)
define({ConoutMode_LFdoesCR},		0x0800)


dnl
dnl
dnl ----- Variables for the console -----
dnl


forget({
DefWord(CO_PUTC)
Compile_LLL({
  DUP ConoutVar_ConsoleBits GetField ConoutFlag_ExistsCursor
  IF
    DUP Conout
    Call_LLL(point(TOS+PutChar),point(TOS+Current),point(TOS+PutChar))
    CO_NextChar
  THEN
})
})
